
//获取数据存储
function getStorage(moduleId) {
    MarsJSBridge.invoke("getStorage", {
        moduleId: 'AP0001',
        type: moduleId,
        group: 'default',
        keys: ['key1', 'key2']
    }, function(res) {
        console.log(res.result)
    });

    MarsJSBridge.invoke("getStorage", {
        moduleId: 'AP0001',
        type: moduleId,
        group: 'group1',
        keys: ['key1', 'key2']
    }, function(res) {
        console.log(res.result)
    });

    MarsJSBridge.invoke("getStorage", {
        moduleId: 'AP0001',
        type: moduleId,
        group: 'group2',
        keys: ['key1', 'key2']
    }, function(res) {
        console.log(res.result)
    });
}

//设置数据存储
function setStorage(moduleId) {
    MarsJSBridge.invoke("setStorage", {
        moduleId: 'AP0001',
        type: moduleId,
        group: 'default',
        data: {
           'key1': 'value1',
           'key2': 'value2'
        }
    });

    MarsJSBridge.invoke("setStorage", {
        moduleId: 'AP0001',
        type: moduleId,
        group: 'group1',
        data: {
           'key1': 'group1_V1',
           'key2': 'group1_v2'
        }
    });

    MarsJSBridge.invoke("setStorage", {
        moduleId: 'AP0001',
        type: moduleId,
        group: 'group2',
        data: {
           'key1': 'group2_v1',
           'key2': 'group2_v2'
        }
    });
}

//删除数据存储
function deleteStorage(moduleId) {
    MarsJSBridge.invoke("deleteStorage", {
        moduleId: 'AP0001',
        type: moduleId,
        group: 'default',
        keys: ['key1']
    });
}

//清空数据存储
function clearStorage(moduleId) {
    MarsJSBridge.invoke("clearStorage", {
        moduleId: 'AP0001',
        type: moduleId,
        scope: "group",
        groups:  ['group1', 'group2']
    });
}


//获取数据存储
function getSecurityStorage(moduleId) {
    MarsJSBridge.invoke("getStorage", {
        moduleId: 'AP0001',
        type: moduleId,
        group: 'default',
        isEncrypted: true,
        keys: ['key_security1', 'key_security2']
    }, function(res) {
        console.log(res.result)
    });
}

//设置数据存储
function setSecurityStorage(moduleId) {
    MarsJSBridge.invoke("setStorage", {
        moduleId: 'AP0001',
        type: moduleId,
        group: 'default',
        isEncrypted: true,
        data: {
           'key_security1': 'value_security1',
           'key_security2': 'value_security2'
        }
    });
}